// Java tool interface class UserInterfaceTool
// This file is generated automatically, please do not edit!
// generation time: Apr 17, 2002 3:51:31 PM

package metastudio;

import aterm.*;
import toolbus.*;
import java.net.*;
import java.util.*;

abstract public class UserInterfaceTool
  extends AbstractTool
  implements UserInterfaceTif
{
  // This table will hold the complete input signature
  private Map sigTable = new HashMap();

  //{{{  Patterns that are used to match against incoming terms

  private ATerm PaddStatus0;
  private ATerm PfinishedOpeningModules0;
  private ATerm PmoduleInfo0;
  private ATerm PaddStatusf0;
  private ATerm Perrorf0;
  private ATerm PgraphLayouted0;
  private ATerm PdeleteModule0;
  private ATerm Perror0;
  private ATerm PnewGraph0;
  private ATerm PendStatus0;
  private ATerm PrecAckEvent0;
  private ATerm PrecTerminate0;

  //}}}

  //{{{  protected UserInterfaceTool(ATermFactory factory)

  // Mimic the constructor from the AbstractTool class
  protected UserInterfaceTool(ATermFactory factory)
  {
    super(factory);
    initSigTable();
    initPatterns();
  }

  //}}}

  //{{{  private void initSigTable()

  // This method initializes the table with input signatures
  private void initSigTable()
  {
    sigTable.put(factory.parse("rec-do(<user-interface>,add-status(<term>,<str>))"), new Boolean(true));
    sigTable.put(factory.parse("rec-do(<user-interface>,add-statusf(<term>,<str>,<list>))"), new Boolean(true));
    sigTable.put(factory.parse("rec-do(<user-interface>,end-status(<term>))"), new Boolean(true));
    sigTable.put(factory.parse("rec-do(<user-interface>,error(<str>))"), new Boolean(true));
    sigTable.put(factory.parse("rec-do(<user-interface>,errorf(<str>,<list>))"), new Boolean(true));
    sigTable.put(factory.parse("rec-do(<user-interface>,finished-opening-modules(<term>))"), new Boolean(true));
    sigTable.put(factory.parse("rec-do(<user-interface>,delete-module(<str>))"), new Boolean(true));
    sigTable.put(factory.parse("rec-do(<user-interface>,module-info(<str>,<list>))"), new Boolean(true));
    sigTable.put(factory.parse("rec-do(<user-interface>,new-graph(<list>,<list>))"), new Boolean(true));
    sigTable.put(factory.parse("rec-do(<user-interface>,graph-layouted(<term>))"), new Boolean(true));
    sigTable.put(factory.parse("rec-ack-event(<user-interface>,<term>)"), new Boolean(true));
    sigTable.put(factory.parse("rec-terminate(<user-interface>,<term>)"), new Boolean(true));
  }

  //}}}
  //{{{  private void initPatterns()

  // Initialize the patterns that are used to match against incoming terms
  private void initPatterns()
  {
    PaddStatus0 = factory.parse("rec-do(add-status(<term>,<str>))");
    PfinishedOpeningModules0 = factory.parse("rec-do(finished-opening-modules(<term>))");
    PmoduleInfo0 = factory.parse("rec-do(module-info(<str>,<term>))");
    PaddStatusf0 = factory.parse("rec-do(add-statusf(<term>,<str>,<term>))");
    Perrorf0 = factory.parse("rec-do(errorf(<str>,<term>))");
    PgraphLayouted0 = factory.parse("rec-do(graph-layouted(<term>))");
    PdeleteModule0 = factory.parse("rec-do(delete-module(<str>))");
    Perror0 = factory.parse("rec-do(error(<str>))");
    PnewGraph0 = factory.parse("rec-do(new-graph(<term>,<term>))");
    PendStatus0 = factory.parse("rec-do(end-status(<term>))");
    PrecAckEvent0 = factory.parse("rec-ack-event(<term>)");
    PrecTerminate0 = factory.parse("rec-terminate(<term>)");
  }

  //}}}

  //{{{  public ATerm handler(ATerm term)

  // The generic handler calls the specific handlers
  public ATerm handler(ATerm term)
  {
    List result;

    result = term.match(PaddStatus0);
    if (result != null) {
      addStatus((ATerm)result.get(0), (String)result.get(1));
      return null;
    }
    result = term.match(PfinishedOpeningModules0);
    if (result != null) {
      finishedOpeningModules((ATerm)result.get(0));
      return null;
    }
    result = term.match(PmoduleInfo0);
    if (result != null) {
      moduleInfo((String)result.get(0), (ATerm)result.get(1));
      return null;
    }
    result = term.match(PaddStatusf0);
    if (result != null) {
      addStatusf((ATerm)result.get(0), (String)result.get(1), (ATerm)result.get(2));
      return null;
    }
    result = term.match(Perrorf0);
    if (result != null) {
      errorf((String)result.get(0), (ATerm)result.get(1));
      return null;
    }
    result = term.match(PgraphLayouted0);
    if (result != null) {
      graphLayouted((ATerm)result.get(0));
      return null;
    }
    result = term.match(PdeleteModule0);
    if (result != null) {
      deleteModule((String)result.get(0));
      return null;
    }
    result = term.match(Perror0);
    if (result != null) {
      error((String)result.get(0));
      return null;
    }
    result = term.match(PnewGraph0);
    if (result != null) {
      newGraph((ATerm)result.get(0), (ATerm)result.get(1));
      return null;
    }
    result = term.match(PendStatus0);
    if (result != null) {
      endStatus((ATerm)result.get(0));
      return null;
    }
    result = term.match(PrecAckEvent0);
    if (result != null) {
      recAckEvent((ATerm)result.get(0));
      return null;
    }
    result = term.match(PrecTerminate0);
    if (result != null) {
      recTerminate((ATerm)result.get(0));
      return null;
    }

      notInInputSignature(term);
    return null;
  }

  //}}}
  //{{{  public void checkInputSignature(ATermList sigs)

  // Check the input signature
  public void checkInputSignature(ATermList sigs)
  {
    while(!sigs.isEmpty()) {
      ATermAppl sig = (ATermAppl)sigs.getFirst();
      sigs = sigs.getNext();
      if (!sigTable.containsKey(sig)) {
        // Sorry, but the term is not in the input signature!
        notInInputSignature(sig);
      }
    }
  }

  //}}}
  //{{{  void notInInputSignature(ATerm t)

  // This function is called when an input term
  // was not in the input signature.
  void notInInputSignature(ATerm t)
  {
    throw new RuntimeException("term not in input signature: "+t);
  }

  //}}}
}
